diff --git a/core/arch/arch_exports.h b/core/arch/arch_exports.h
index 0aa0ffc054..0d6a9fb005 100644
--- a/core/arch/arch_exports.h
+++ b/core/arch/arch_exports.h
@@ -2218,6 +2218,9 @@ finalize_selfmod_sandbox(dcontext_t *dcontext, fragment_t *f);
 bool
 instr_check_xsp_mangling(dcontext_t *dcontext, instr_t *inst, int *xsp_adjust);
 
+bool
+instr_supports_simple_mangling_epilogue(dcontext_t *dcontext, instr_t *inst);
+
 void
 float_pc_update(dcontext_t *dcontext);
 
diff --git a/core/arch/instr.h b/core/arch/instr.h
index 64255acb2c..5ebbbfad28 100644
--- a/core/arch/instr.h
+++ b/core/arch/instr.h
@@ -191,9 +191,18 @@ enum {
 #    endif
 
 #    ifdef CLIENT_INTERFACE
+    /* This enum is also used for INSTR_OUR_MANGLING_EPILOGUE. Its semantics are
+     * orthogonal to this and must not overlap.
+     */
     INSTR_CLOBBER_RETADDR = 0x02000000,
 #    endif
 
+    /* Indicates that the instruction is part of an own mangling region's
+     * epilogue (xref i#3307). Currently, instructions with the
+     * INSTR_CLOBBER_RETADDR property are never in a mangling epilogue, which
+     * is why we are reusing its enum value here.
+     * */
+    INSTR_OUR_MANGLING_EPILOGUE = 0x02000000,
     /* Signifies that this instruction may need to be hot patched and should
      * therefore not cross a cache line. It is not necessary to set this for
      * exit cti's or linkstubs since it is mainly intended for clients etc.
@@ -1840,6 +1849,24 @@ instr_is_our_mangling(instr_t *instr);
 void
 instr_set_our_mangling(instr_t *instr, bool ours);
 
+/* Returns whether instr came from our mangling and is in epilogue. This routine
+ * requires the caller to already know that instr is our_mangling.
+ */
+bool
+instr_is_our_mangling_epilogue(instr_t *instr);
+
+/* Sets whether instr came from our mangling and is in epilogue. */
+void
+instr_set_our_mangling_epilogue(instr_t *instr, bool epilogue);
+
+/* Sets that instr is in our mangling epilogue as well as the translation pointer
+ * for instr, by adding the translation pointer of mangle_instr to its length.
+ * Returns the instr.
+ */
+instr_t *
+instr_set_translation_mangling_epilogue(dcontext_t *dcontext, instrlist_t *ilist,
+                                        instr_t *instr);
+
 DR_API
 /**
  * Returns NULL if none of \p instr's operands is a memory reference.
diff --git a/core/arch/instr_shared.c b/core/arch/instr_shared.c
index 867744f2e5..42109afbdd 100644
--- a/core/arch/instr_shared.c
+++ b/core/arch/instr_shared.c
@@ -2159,6 +2159,36 @@ instr_set_our_mangling(instr_t *instr, bool ours)
         instr->flags &= ~INSTR_OUR_MANGLING;
 }
 
+bool
+instr_is_our_mangling_epilogue(instr_t *instr)
+{
+    ASSERT(!TEST(INSTR_OUR_MANGLING_EPILOGUE, instr->flags) ||
+           instr_is_our_mangling(instr));
+    return TEST(INSTR_OUR_MANGLING_EPILOGUE, instr->flags);
+}
+
+void
+instr_set_our_mangling_epilogue(instr_t *instr, bool epilogue)
+{
+    if (epilogue) {
+        instr->flags |= INSTR_OUR_MANGLING_EPILOGUE;
+    } else
+        instr->flags &= ~INSTR_OUR_MANGLING_EPILOGUE;
+}
+
+instr_t *
+instr_set_translation_mangling_epilogue(dcontext_t *dcontext, instrlist_t *ilist,
+                                        instr_t *instr)
+{
+    if (instrlist_get_translation_target(ilist) != NULL) {
+        int sz = decode_sizeof(dcontext, instrlist_get_translation_target(ilist),
+                               NULL _IF_X86_64(NULL));
+        instr_set_translation(instr, instrlist_get_translation_target(ilist) + sz);
+    }
+    instr_set_our_mangling_epilogue(instr, true);
+    return instr;
+}
+
 /* Emulates instruction to find the address of the index-th memory operand.
  * Either or both OUT variables can be NULL.
  */
diff --git a/core/arch/mangle_shared.c b/core/arch/mangle_shared.c
index 85a62223fe..2e495079a7 100644
--- a/core/arch/mangle_shared.c
+++ b/core/arch/mangle_shared.c
@@ -798,6 +798,19 @@ mangle(dcontext_t *dcontext, instrlist_t *ilist, uint *flags INOUT, bool mangle_
      * -- ifdef UNIX, mangle seg ref and mov_seg
      */
 
+    /* Mangling routines need to be careful about whether or not to flag mangling
+     * epilogue instructions (xref i#3307).
+     * -- should be marked with mangling epilogue flag, if it can be translated to
+          the next PC post-app instruction using/abusing translate_walk_restore.
+     * -- should not be marked with mangling epilogue flag, it either is 1) logically not
+          a PC post-app instruction, which is the case for control-flow instructions.
+          Or 2) it is unsupported to advance to the next PC, and we're making the
+          assumption here that all such instructions can be fully rolled back to the
+          current PC.
+     * Mangling routines should set mangling epilogue flag manually. This could get
+     * improved by doing this automatically for next_instr, unless explictly flagged.
+     */
+
     KSTART(mangling);
     instrlist_set_our_mangling(ilist, true); /* PR 267260 */
 
diff --git a/core/arch/x86/mangle.c b/core/arch/x86/mangle.c
index 4e3fdef923..a37c080f46 100644
--- a/core/arch/x86/mangle.c
+++ b/core/arch/x86/mangle.c
@@ -1259,6 +1259,19 @@ instr_check_xsp_mangling(dcontext_t *dcontext, instr_t *inst, int *xsp_adjust)
     return true;
 }
 
+/* Returns whether the instruction supports a simple mangling epilogue that is supported
+ * to xl8 to the next program counter post original app instruction.
+ */
+bool
+instr_supports_simple_mangling_epilogue(dcontext_t *dcontext, instr_t *inst)
+{
+    /* XXX we expect the check in translate_walk_restore to fail if any other type
+     * of mangling overlaps with rip-rel mangling than the supported ones. Currently,
+     * this are only rip-rel control-flow instructions which are excluded here.
+     */
+    return !instr_is_cti(inst);
+}
+
 /* N.B.: keep in synch with instr_check_xsp_mangling() */
 void
 insert_push_retaddr(dcontext_t *dcontext, instrlist_t *ilist, instr_t *instr,
@@ -2162,6 +2175,9 @@ mangle_syscall_arch(dcontext_t *dcontext, instrlist_t *ilist, uint flags, instr_
                                         NULL);
         /* sysenter goes here */
         PRE(ilist, next_instr, post_sysenter);
+        /* XXX i#3307: unimplemented, we can only support simple mangling cases in
+         * mangling epilogue.
+         */
         PRE(ilist, next_instr,
             RESTORE_FROM_DC_OR_TLS(dcontext, flags, REG_XDX, TLS_XDX_SLOT, XDX_OFFSET));
         PRE(ilist, next_instr,
@@ -2943,9 +2959,27 @@ mangle_rel_addr(dcontext_t *dcontext, instrlist_t *ilist, instr_t *instr,
             /* we need the whole spill...restore region to all be marked mangle */
             instr_set_our_mangling(instr, true);
             if (spill) {
+                /* We are making several assumptions here. Firstly, we assume that any
+                 * instruction in the mangling code of any control-flow app instruction
+                 * is always before the last commit point of the app instruction, i.e.
+                 * does not xl8 to a PC post app instruction. This should be safe to
+                 * assume for any control-flow instruction. We therefore do not mark the
+                 * rip-rel related restores here as 'epilogue'. Secondly, we assume that
+                 * no instructions in mangled code that require xsp adjustment to xl8 app
+                 * state are instructions that can be fully rolled back. There is a check
+                 * in translate_walk_restore that makes sure there is no xsp_adjust for
+                 * instructions in mangling epilogue. Both of this includes instructions
+                 * with further mangling after the rip-rel mangling code that require
+                 * roll-back. We assume here that this is supported for all such
+                 * instructions.
+                 */
+                instr_t *restore = instr_create_restore_from_tls(
+                    dcontext, scratch_reg, MANGLE_RIPREL_SPILL_SLOT);
                 PRE(ilist, next_instr,
-                    instr_create_restore_from_tls(dcontext, scratch_reg,
-                                                  MANGLE_RIPREL_SPILL_SLOT));
+                    instr_supports_simple_mangling_epilogue(dcontext, instr)
+                        ? instr_set_translation_mangling_epilogue(dcontext, ilist,
+                                                                  restore)
+                        : restore);
             }
             STATS_INC(rip_rel_unreachable);
         }
@@ -3191,8 +3225,11 @@ mangle_seg_ref(dcontext_t *dcontext, instrlist_t *ilist, instr_t *instr,
 
     if (spill) {
         PRE(ilist, next_instr,
-            instr_create_restore_from_tls(dcontext, scratch_reg,
-                                          tls_slots[scratch_reg - REG_XAX]));
+            /* XXX i#3307: needs test. */
+            instr_set_translation_mangling_epilogue(
+                dcontext, ilist,
+                instr_create_restore_from_tls(dcontext, scratch_reg,
+                                              tls_slots[scratch_reg - REG_XAX])));
     }
 }
 #    endif /* UNIX */
diff --git a/core/translate.c b/core/translate.c
index a89ba9c6cf..6acd11b744 100644
--- a/core/translate.c
+++ b/core/translate.c
@@ -93,6 +93,8 @@ typedef struct _translate_walk_t {
     bool unsupported_mangle;
     /* Are we currently in a mangle region */
     bool in_mangle_region;
+    /* Are we currently in a mangle region's epilogue */
+    bool in_mangle_region_epilogue;
     /* What is the translation target of the current mangle region */
     app_pc translation;
 } translate_walk_t;
@@ -167,6 +169,25 @@ instr_is_mov_PC_immed(dcontext_t *dcontext, instr_t *inst)
 }
 #endif
 
+#ifdef X86
+
+/* FIXME i#3329: add support for ARM/AArch64. */
+
+static bool
+translate_walk_enters_mangling_epilogue(dcontext_t *tdcontext, instr_t *inst,
+                                        translate_walk_t *walk)
+{
+    return !walk->in_mangle_region_epilogue && instr_is_our_mangling_epilogue(inst);
+}
+
+static bool
+translate_walk_exits_mangling_epilogue(dcontext_t *tdcontext, instr_t *inst,
+                                       translate_walk_t *walk)
+{
+    return walk->in_mangle_region_epilogue && !instr_is_our_mangling_epilogue(inst);
+}
+#endif
+
 static void
 translate_walk_track(dcontext_t *tdcontext, instr_t *inst, translate_walk_t *walk)
 {
@@ -177,13 +198,18 @@ translate_walk_track(dcontext_t *tdcontext, instr_t *inst, translate_walk_t *wal
     if (walk->in_mangle_region &&
         /* On ARM, we spill registers across an app instr, so go solely on xl8 */
         (IF_X86(!instr_is_our_mangling(inst) ||)
-             instr_get_translation(inst) != walk->translation)) {
+         /* handle adjacent mangle regions */
+         IF_X86(translate_walk_exits_mangling_epilogue(tdcontext, inst, walk) ||)
+         /* Entering the mangling region's epilogue can have different xl8 */
+         (IF_X86(!translate_walk_enters_mangling_epilogue(tdcontext, inst, walk) &&)
+              instr_get_translation(inst) != walk->translation))) {
         LOG(THREAD_GET, LOG_INTERP, 5, "%s: from one mangle region to another\n",
             __FUNCTION__);
         /* We assume our manglings are local and contiguous: once out of a
          * mangling region, we're good to go again.
          */
         walk->in_mangle_region = false;
+        walk->in_mangle_region_epilogue = false;
         walk->unsupported_mangle = false;
         walk->xsp_adjust = 0;
         for (r = 0; r < REG_SPILL_NUM; r++) {
@@ -225,6 +251,14 @@ translate_walk_track(dcontext_t *tdcontext, instr_t *inst, translate_walk_t *wal
             walk->translation = instr_get_translation(inst);
             LOG(THREAD_GET, LOG_INTERP, 5, "%s: entering mangle region xl8=" PFX "\n",
                 __FUNCTION__, walk->translation);
+        } else if (IF_X86_ELSE(
+                       translate_walk_enters_mangling_epilogue(tdcontext, inst, walk),
+                       false)) {
+            walk->in_mangle_region_epilogue = true;
+            walk->translation = instr_get_translation(inst);
+            LOG(THREAD_GET, LOG_INTERP, 5,
+                "%s: entering mangle region epilogue xl8=" PFX "\n", __FUNCTION__,
+                walk->translation);
         } else
             ASSERT(walk->translation == instr_get_translation(inst));
         /* PR 302951: we recognize a clean call by its NULL translation.
@@ -387,16 +421,63 @@ translate_walk_good_state(dcontext_t *tdcontext, translate_walk_t *walk,
                           app_pc translate_pc)
 {
     return (!walk->unsupported_mangle ||
-            /* If we're at the instr AFTER the mangle region, we're ok */
+            /* If we're at the instr AFTER the mangle region, or at an instruction
+             * in the mangled region's EPILOGUE, we're ok.
+             */
             (walk->in_mangle_region && translate_pc != walk->translation));
 }
 
 static void
-translate_walk_restore(dcontext_t *tdcontext, translate_walk_t *walk, app_pc translate_pc)
+translate_walk_restore(dcontext_t *tdcontext, translate_walk_t *walk, instr_t *inst,
+                       app_pc translate_pc)
 {
     reg_id_t r;
 
-    if (translate_pc != walk->translation) {
+    if (IF_X86_ELSE(translate_walk_enters_mangling_epilogue(tdcontext, inst, walk),
+                    false)) {
+        /* We handle only simple symmetric one-spill/one-restore mangling cases
+         * when xl8 inst addresses in mangling epilogue. Everything else is
+         * currently not supported. In this case, the restore routine here acts
+         * as if it was emulating the epilogue instructions, because we xl8 the
+         * PC post-app instruction. This is semantically different from restoring
+         * the state pre-app instruction, as this routine originally intended.
+         * This works, because only the simple spill-restore mangle case is
+         * supported (xref i#3307). For more complex cases, this should get factored
+         * out into a separate routine that walks the epilogue and advances the state
+         * accordingly.
+         */
+        LOG(THREAD_GET, LOG_INTERP, 2,
+            "\ttranslation " PFX " is in mangling epilogue " PFX
+            " checking for simple symmetric mangling case\n",
+            translate_pc, walk->translation);
+        DOCHECK(1, {
+            bool spill_seen = false;
+            for (r = 0; r < REG_SPILL_NUM; r++) {
+                if (walk->reg_spilled[r]) {
+                    ASSERT_NOT_IMPLEMENTED(!spill_seen);
+                    spill_seen = true;
+                }
+            }
+            bool tls;
+            bool spill;
+            uint offs;
+            if (instr_is_reg_spill_or_restore(tdcontext, inst, &tls, &spill, NULL,
+                                              &offs)) {
+                ASSERT_NOT_IMPLEMENTED(!spill);
+            } else if (!tls || offs == -1 ||
+                       offs != os_tls_offset((ushort)MANGLE_RIPREL_SPILL_SLOT)) {
+                /* Riprel mangling can put arbitrary registers into
+                 * MANGLE_RIPREL_SPILL_SLOT and as such is not recognized as regular
+                 * spill/restore by instr_is_reg_spill_or_restore. Either way, we don't
+                 * support cases that are more complex than one spill and restore in this
+                 * context if instruction was part of mangling epilogue.
+                 */
+                ASSERT_NOT_IMPLEMENTED(false);
+            }
+            /* Enforcing here what mangling needs to obey. */
+            ASSERT_NOT_IMPLEMENTED(walk->xsp_adjust == 0);
+        });
+    } else if (translate_pc != walk->translation) {
         /* When we walk we update only each instr we pass.  If we're
          * now sitting at the instr AFTER the mangle region, we do
          * NOT want to adjust xsp, since we're not translating to
@@ -406,6 +487,9 @@ translate_walk_restore(dcontext_t *tdcontext, translate_walk_t *walk, app_pc tra
             "\ttranslation " PFX " is post-walk " PFX " so not fixing xsp\n",
             translate_pc, walk->translation);
         DOCHECK(1, {
+            /* Assumes all spills are matched by the same number of restores. This
+             * assumption may not hold for more complex mangling.
+             */
             for (r = 0; r < REG_SPILL_NUM; r++)
                 ASSERT(!walk->reg_spilled[r]
                         /* Register X0 is used for branches on AArch64.
@@ -602,7 +686,7 @@ recreate_app_state_from_info(dcontext_t *tdcontext, const translation_info_t *in
     }
 
     if (!just_pc)
-        translate_walk_restore(tdcontext, &walk, answer);
+        translate_walk_restore(tdcontext, &walk, &instr, answer);
     LOG(THREAD_GET, LOG_INTERP, 2, "recreate_app -- found ok pc " PFX "\n", answer);
     mc->pc = answer;
     return res;
@@ -794,7 +878,7 @@ recreate_app_state_from_ilist(dcontext_t *tdcontext, instrlist_t *ilist, byte *s
                 }
             }
             if (!just_pc)
-                translate_walk_restore(tdcontext, &walk, answer);
+                translate_walk_restore(tdcontext, &walk, inst, answer);
             LOG(THREAD_GET, LOG_INTERP, 2, "recreate_app -- found ok pc " PFX "\n",
                 answer);
             mc->pc = answer;
@@ -1598,7 +1682,7 @@ stress_test_recreate_state(dcontext_t *dcontext, fragment_t *f, instrlist_t *ili
     priv_mcontext_t mc;
     bool res;
     cache_pc cpc;
-    instr_t *in;
+    instr_t *in, *prev_in = NULL;
     static const reg_t STRESS_XSP_INIT = 0x08000000; /* arbitrary */
     bool success_so_far = true;
     bool inside_mangle_region = false;
@@ -1632,7 +1716,10 @@ stress_test_recreate_state(dcontext_t *dcontext, fragment_t *f, instrlist_t *ili
             (!instr_is_our_mangling(in) ||
              /* handle adjacent mangle regions */
              (TEST(FRAG_IS_TRACE, f->flags) /* we have translation only for traces */ &&
-              mangle_translation != instr_get_translation(in)))) {
+              IF_X86((prev_in != NULL &&
+                      (instr_is_our_mangling_epilogue(prev_in) ||
+                       !instr_is_our_mangling_epilogue(in))) &&)
+                      mangle_translation != instr_get_translation(in)))) {
             /* reset */
             LOG(THREAD, LOG_INTERP, 3, "  out of mangling region\n");
             inside_mangle_region = false;
@@ -1641,6 +1728,7 @@ stress_test_recreate_state(dcontext_t *dcontext, fragment_t *f, instrlist_t *ili
             spill_xcx_outstanding = false;
             /* go ahead and fall through and ensure we succeed w/ 0 xsp adjust */
         }
+        prev_in = in;
 
         if (instr_is_our_mangling(in)) {
             if (!inside_mangle_region) {
@@ -1649,7 +1737,8 @@ stress_test_recreate_state(dcontext_t *dcontext, fragment_t *f, instrlist_t *ili
                 mangle_translation = instr_get_translation(in);
             } else {
                 ASSERT(!TEST(FRAG_IS_TRACE, f->flags) ||
-                       mangle_translation == instr_get_translation(in));
+                       IF_X86(instr_is_our_mangling_epilogue(in) ||)
+                               mangle_translation == instr_get_translation(in));
             }
 
             mc.xcx =
diff --git a/core/unix/os_public.h b/core/unix/os_public.h
index 77286d2540..8f8dce6f72 100644
--- a/core/unix/os_public.h
+++ b/core/unix/os_public.h
@@ -97,6 +97,15 @@ typedef kernel_sigcontext_t sigcontext_t;
 #        define SC_XBP SC_FIELD(rbp)
 #        define SC_XSI SC_FIELD(rsi)
 #        define SC_XDI SC_FIELD(rdi)
+#        define SC_R8 SC_FIELD(r9)
+#        define SC_R9 SC_FIELD(r9)
+#        define SC_R10 SC_FIELD(r10)
+#        define SC_R11 SC_FIELD(r11)
+#        define SC_R12 SC_FIELD(r12)
+#        define SC_R13 SC_FIELD(r13)
+#        define SC_R14 SC_FIELD(r14)
+#        define SC_R15 SC_FIELD(r15)
+
 #        ifdef MACOS
 #            define SC_XFLAGS SC_FIELD(rflags)
 #        else
diff --git a/suite/tests/CMakeLists.txt b/suite/tests/CMakeLists.txt
index d176a3692c..95be6bb68c 100644
--- a/suite/tests/CMakeLists.txt
+++ b/suite/tests/CMakeLists.txt
@@ -1946,6 +1946,14 @@ if (CLIENT_INTERFACE)
         "" "${trace_arg}" "${events_appdll_path}")
       tobuild_ci(client.nudge_test client-interface/nudge_test.runall "" "" "")
       tobuild_ci(client.timer client-interface/timer.c "" "" "")
+      if (X64)
+        tobuild_ci(client.mangle_suspend client-interface/mangle_suspend.c ""
+          "-vm_base 0x100000000 -no_vm_base_near_app" "")
+        use_DynamoRIO_extension(client.mangle_suspend.dll drmgr)
+        target_include_directories(client.mangle_suspend PRIVATE
+          ${CMAKE_CURRENT_SOURCE_DIR}/client-interface)
+        link_with_pthread(client.mangle_suspend)
+      endif ()
     endif (NOT ARM)
     if (X86 OR AARCH64) # FIXME i#1551: port asm to AArch32
       tobuild_ci(client.syscall-mod client-interface/syscall-mod.c "" "" "")
@@ -3143,6 +3151,16 @@ if (UNIX)
 
     tobuild(linux.signest linux/signest.c)
     link_with_pthread(linux.signest)
+
+    if (UNIX)
+      if (X64)
+        # XXX i#3307: add Windows test.
+        tobuild_ops(linux.mangle_asynch linux/mangle_asynch.c "-vm_base 0x100000000 -no_vm_base_near_app" "")
+        target_include_directories(linux.mangle_asynch PRIVATE
+          ${CMAKE_CURRENT_SOURCE_DIR}/linux)
+        link_with_pthread(linux.mangle_asynch)
+      endif ()
+    endif ()
   endif ()
 
   # We pass -native_exec_list which causes us to call strcasecmp in libc,
diff --git a/suite/tests/client-interface/mangle_suspend-shared.h b/suite/tests/client-interface/mangle_suspend-shared.h
new file mode 100644
index 0000000000..469951e418
--- /dev/null
+++ b/suite/tests/client-interface/mangle_suspend-shared.h
@@ -0,0 +1,62 @@
+/* **********************************************************
+ * Copyright (c) 2015-2018 Google, Inc.  All rights reserved.
+ * **********************************************************/
+
+/*
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * * Redistributions of source code must retain the above copyright notice,
+ *   this list of conditions and the following disclaimer.
+ *
+ * * Redistributions in binary form must reproduce the above copyright notice,
+ *   this list of conditions and the following disclaimer in the documentation
+ *   and/or other materials provided with the distribution.
+ *
+ * * Neither the name of Google, Inc. nor the names of its contributors may be
+ *   used to endorse or promote products derived from this software without
+ *   specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL GOOGLE, INC. OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+ * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
+ * DAMAGE.
+ */
+
+#ifdef X86
+#    define LOOP_TEST_REG DR_REG_XBX
+#    define LOOP_TEST_REG_ASM REG_XBX
+#    define LOOP_TEST_REG_SIG SC_XBX
+#    define LOOP_COUNT_REG DR_REG_XCX
+#    define LOOP_COUNT_REG_ASM REG_XCX
+#    define LOOP_COUNT_REG_SIG SC_XCX
+#    define LOOP_COUNT_REG_MC mc.xcx
+#    define SUSPEND_TEST_REG DR_REG_XDX
+#    define SUSPEND_TEST_REG_ASM REG_XDX
+#    define SUSPEND_TEST_REG_SIG SC_XDX
+#endif
+
+#define LOOP_COUNT 10000000000
+
+#define MAKE_HEX_ASM(n) HEX(n)
+#define MAKE_HEX(n) 0x##n
+#define MAKE_HEX_C(n) MAKE_HEX(n)
+
+/* Immediates that we look for in the app code to identify places for
+ * specific tests in the client.
+ * We limit to 16 bits to work on ARM.
+ */
+#define TEST_CONST(num) f1f##num
+
+#define TEST_VAL MAKE_HEX_ASM(TEST_CONST(1))
+#define TEST_VAL_C MAKE_HEX_C(TEST_CONST(1))
+
+#define SUSPEND_VAL MAKE_HEX_ASM(TEST_CONST(2))
+#define SUSPEND_VAL_C MAKE_HEX_C(TEST_CONST(2))
diff --git a/suite/tests/client-interface/mangle_suspend.c b/suite/tests/client-interface/mangle_suspend.c
new file mode 100644
index 0000000000..24d7c0ffd4
--- /dev/null
+++ b/suite/tests/client-interface/mangle_suspend.c
@@ -0,0 +1,173 @@
+/* **********************************************************
+ * Copyright (c) 2015-2018 Google, Inc.  All rights reserved.
+ * **********************************************************/
+
+/*
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * * Redistributions of source code must retain the above copyright notice,
+ *   this list of conditions and the following disclaimer.
+ *
+ * * Redistributions in binary form must reproduce the above copyright notice,
+ *   this list of conditions and the following disclaimer in the documentation
+ *   and/or other materials provided with the distribution.
+ *
+ * * Neither the name of Google, Inc. nor the names of its contributors may be
+ *   used to endorse or promote products derived from this software without
+ *   specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL GOOGLE, INC. OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+ * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
+ * DAMAGE.
+ */
+
+/* Test xl8 pc of rip-rel instruction (xref #3307) in mangling epilogue, caused
+ * by asynch interrupt.
+ */
+
+#ifndef ASM_CODE_ONLY /* C code */
+#    include "configure.h"
+#    ifndef UNIX
+#        error UNIX-only
+#    endif
+#    include "tools.h"
+#    include "mangle_suspend-shared.h"
+#    include <setjmp.h>
+#    include <signal.h>
+#    include <pthread.h>
+
+volatile bool test_ready = false;
+volatile bool test_done = false;
+volatile int loop_inc = 1;
+
+/* asm routines */
+void
+test_asm();
+
+static void *
+suspend_thread_routine(void *arg)
+{
+#    ifdef X86_64
+    /* This thread is executing labels for the client to insert a clean call that
+     * does the suspend and subsequent check for correctness.
+     */
+    while (!test_ready) {
+        /* Empty. */
+    }
+    struct timespec sleeptime;
+    sleeptime.tv_sec = 0;
+    /* Pick an uneven number to maximize the number of suspend calls w/o
+     * running into limitations in DR.
+     */
+    sleeptime.tv_nsec = 2000 * 1111;
+    while (!test_done) {
+        asm volatile("mov %0, %%rdx\n\t"
+                     "mov %0, %%rdx\n"
+                     :
+                     : "i"(SUSPEND_VAL_C)
+                     : "rdx");
+        nanosleep(&sleeptime, NULL);
+    }
+#    endif
+    return NULL;
+}
+
+int
+main(int argc, const char *argv[])
+{
+    pthread_t suspend_thread;
+    void *retval;
+
+    if (pthread_create(&suspend_thread, NULL, suspend_thread_routine, NULL) != 0) {
+        perror("Failed to create thread");
+        exit(1);
+    }
+
+    /* Test xl8 pc of rip-rel instruction (xref #3307) in mangling epilogue, caused by
+     * asynch interrupt.
+     */
+    test_asm();
+
+    if (pthread_join(suspend_thread, &retval) != 0)
+        perror("Failed to join thread");
+
+    print("Test finished\n");
+    return 0;
+}
+
+#else /* asm code *************************************************************/
+#    include "asm_defines.asm"
+#    include "mangle_suspend-shared.h"
+/* clang-format off */
+START_FILE
+
+#ifdef X64
+# define FRAME_PADDING 0
+#else
+# define FRAME_PADDING 0
+#endif
+
+#define FUNCNAME test_asm
+        DECLARE_FUNC_SEH(FUNCNAME)
+GLOBAL_LABEL(FUNCNAME:)
+#ifdef X86
+#ifdef X64
+        PUSH_CALLEE_SAVED_REGS()
+        sub      REG_XSP, FRAME_PADDING /* align */
+        END_PROLOG
+
+        jmp      test
+     test:
+        mov      PTRSZ [REG_XSP], LOOP_COUNT_REG_ASM
+        sub      REG_XSP, 8
+        mov      SUSPEND_TEST_REG_ASM, TEST_VAL
+        mov      SUSPEND_TEST_REG_ASM, TEST_VAL
+        nop
+        mov      BYTE SYMREF(test_ready), HEX(1)
+        mov      LOOP_TEST_REG_ASM, LOOP_COUNT
+        mov      LOOP_COUNT_REG_ASM, 2
+
+      loop:
+        /* XXX i#3327: add zero check for REG_XCX in client dll. */
+        /* mov      REG_XCX, HEX(0) */
+        mov      LOOP_COUNT_REG_ASM, 1
+        add      LOOP_COUNT_REG_ASM, PTRSZ SYMREF(loop_inc)
+        mov      LOOP_COUNT_REG_ASM, 2
+        sub      LOOP_TEST_REG_ASM, 1
+        cmp      LOOP_TEST_REG_ASM, 0
+        jnz      loop
+
+        jmp      epilog
+     epilog:
+        mov      BYTE SYMREF(test_done), HEX(1)
+        add      REG_XSP, 8
+        mov      LOOP_COUNT_REG_ASM, PTRSZ [REG_XSP]
+        add      REG_XSP, FRAME_PADDING /* make a legal SEH64 epilog */
+        POP_CALLEE_SAVED_REGS()
+#endif
+        ret
+#elif defined(ARM)
+        /* XXX i#3289: prologue missing */
+        /* Test: not implemented for ARM */
+        bx       lr
+#elif defined(AARCH64)
+        /* XXX i#3289: prologue missing */
+        /* Test: not implemented for AARCH64 */
+        ret
+#endif
+        END_FUNC(FUNCNAME)
+#undef FUNCNAME
+
+END_FILE
+
+/* clang-format on */
+#endif
diff --git a/suite/tests/client-interface/mangle_suspend.dll.c b/suite/tests/client-interface/mangle_suspend.dll.c
new file mode 100644
index 0000000000..c8f6aed9c3
--- /dev/null
+++ b/suite/tests/client-interface/mangle_suspend.dll.c
@@ -0,0 +1,188 @@
+/* **********************************************************
+ * Copyright (c) 2015-2018 Google, Inc.  All rights reserved.
+ * **********************************************************/
+
+/*
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * * Redistributions of source code must retain the above copyright notice,
+ *   this list of conditions and the following disclaimer.
+ *
+ * * Redistributions in binary form must reproduce the above copyright notice,
+ *   this list of conditions and the following disclaimer in the documentation
+ *   and/or other materials provided with the distribution.
+ *
+ * * Neither the name of Google, Inc. nor the names of its contributors may be
+ *   used to endorse or promote products derived from this software without
+ *   specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL GOOGLE, INC. OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+ * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
+ * DAMAGE.
+ */
+
+/* Test xl8 pc of rip-rel instruction (xref #3307) caused by
+ * asynch interrupt.
+ */
+
+#include "dr_api.h"
+#include "drmgr.h"
+#include "client_tools.h"
+#include "mangle_suspend-shared.h"
+#include <string.h> /* memset */
+
+#define MAX_RESUME_COUNT 10
+
+#define CHECK(x, msg)                                                                \
+    do {                                                                             \
+        if (!(x)) {                                                                  \
+            dr_fprintf(STDERR, "CHECK failed %s:%d: %s\n", __FILE__, __LINE__, msg); \
+            dr_abort();                                                              \
+        }                                                                            \
+    } while (0);
+
+extern void
+test_asm();
+
+static byte *add_instr_pc = NULL;
+
+static dr_emit_flags_t
+event_app_analysis(void *drcontext, void *tag, instrlist_t *bb, bool for_trace,
+                   bool translating, OUT void **user_data)
+{
+    instr_t *inst;
+    bool prev_was_mov_const = false;
+    ptr_int_t val1, val2;
+    *user_data = NULL;
+
+    if (translating)
+        return DR_EMIT_DEFAULT;
+
+#ifdef X86_64
+    /* Look for duplicate mov immediates telling us which subaction we're in */
+    for (inst = instrlist_first_app(bb); inst != NULL; inst = instr_get_next_app(inst)) {
+        if (instr_is_mov_constant(inst, prev_was_mov_const ? &val2 : &val1)) {
+            if (prev_was_mov_const && val1 == val2 &&
+                val1 != 0 && /* rule out xor w/ self */
+                opnd_is_reg(instr_get_dst(inst, 0)) &&
+                opnd_get_reg(instr_get_dst(inst, 0)) == SUSPEND_TEST_REG) {
+                *user_data = (void *)val1;
+                instrlist_meta_postinsert(bb, inst, INSTR_CREATE_label(drcontext));
+            } else
+                prev_was_mov_const = true;
+        } else
+            prev_was_mov_const = false;
+    }
+#else
+        /* XXX i#3329: port to ARM if possible. */
+#endif
+    return DR_EMIT_DEFAULT;
+}
+
+static void
+suspend_func()
+{
+#ifdef X86_64
+    void **drcontexts = NULL;
+    uint num_suspended;
+    if (dr_suspend_all_other_threads(&drcontexts, &num_suspended, NULL)) {
+        if (num_suspended != 1)
+            CHECK(false, "num_suspended unexpected!");
+        dr_mcontext_t mc = { sizeof(mc), DR_MC_INTEGER | DR_MC_CONTROL };
+        if (!dr_get_mcontext(drcontexts[0], &mc))
+            CHECK(false, "dr_get_mcontext failed!");
+        /* Check xip such that we only perform the check if we are in the loop
+         * body of the test, in order to avoid races. The magic values 7 and 24
+         * are byte counts to compute the bounds of the asm loop in the test.
+         * The values need to stay in synch with the test.
+         */
+        if (mc.xip >= add_instr_pc - 7 && mc.xip <= add_instr_pc + 24) {
+            if (add_instr_pc == mc.xip) {
+                if (LOOP_COUNT_REG_MC != 1) {
+                    CHECK(false, "loop count reg expected to be 1");
+                    exit(1);
+                }
+            } else if (LOOP_COUNT_REG_MC != 2) {
+                CHECK(false, "loop count reg expected to be 2");
+                exit(1);
+            }
+        }
+        int resume_count = 0;
+        while (!dr_resume_all_other_threads(drcontexts, num_suspended)) {
+            if (resume_count++ == MAX_RESUME_COUNT) {
+                CHECK(false, "resume failed!");
+                exit(1);
+            }
+        }
+    }
+#else
+    /* XXX i#3329: port to ARM if possible. */
+#endif
+}
+
+static dr_emit_flags_t
+event_app_instruction(void *drcontext, void *tag, instrlist_t *bb, instr_t *inst,
+                      bool for_trace, bool translating, void *user_data)
+{
+    ptr_int_t subaction = (ptr_int_t)user_data;
+
+    if (translating)
+        return DR_EMIT_DEFAULT;
+
+    if (subaction == TEST_VAL_C) {
+        if (instr_is_label(inst)) {
+#ifdef X86_64
+            byte *pc = tag;
+            for (instr_t *inst = instrlist_first(bb); inst; inst = instr_get_next(inst)) {
+                if (pc == NULL)
+                    CHECK(false, "Unexpected decode error");
+                if (instr_get_opcode(inst) == OP_add &&
+                    instr_has_rel_addr_reference(inst)) {
+                    add_instr_pc = instr_get_app_pc(inst);
+                    return DR_EMIT_DEFAULT;
+                }
+            }
+            CHECK(false, "add instruction not found");
+#endif
+        }
+    } else if (subaction == SUSPEND_VAL_C) {
+        if (instr_is_label(inst)) {
+            /* This is expected to be in a separate thread that the test creates. The
+             * test is just executing the label instructions in a loop.
+             */
+            dr_insert_clean_call(drcontext, bb, inst, suspend_func, false, 0);
+        }
+    }
+
+    return DR_EMIT_DEFAULT;
+}
+
+static void
+event_exit(void)
+{
+    if (!drmgr_unregister_bb_insertion_event(event_app_instruction))
+        CHECK(false, "exit failed");
+
+    drmgr_exit();
+}
+
+DR_EXPORT void
+dr_init(client_id_t id)
+{
+    if (!drmgr_init())
+        CHECK(false, "init failed");
+    /* register events */
+    dr_register_exit_event(event_exit);
+    if (!drmgr_register_bb_instrumentation_event(event_app_analysis,
+                                                 event_app_instruction, NULL))
+        CHECK(false, "init failed");
+}
diff --git a/suite/tests/client-interface/mangle_suspend.expect b/suite/tests/client-interface/mangle_suspend.expect
new file mode 100644
index 0000000000..5d024cd516
--- /dev/null
+++ b/suite/tests/client-interface/mangle_suspend.expect
@@ -0,0 +1 @@
+Test finished
diff --git a/suite/tests/linux/mangle_asynch-shared.h b/suite/tests/linux/mangle_asynch-shared.h
new file mode 100644
index 0000000000..5f21f42867
--- /dev/null
+++ b/suite/tests/linux/mangle_asynch-shared.h
@@ -0,0 +1,42 @@
+/* **********************************************************
+ * Copyright (c) 2015-2018 Google, Inc.  All rights reserved.
+ * **********************************************************/
+
+/*
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * * Redistributions of source code must retain the above copyright notice,
+ *   this list of conditions and the following disclaimer.
+ *
+ * * Redistributions in binary form must reproduce the above copyright notice,
+ *   this list of conditions and the following disclaimer in the documentation
+ *   and/or other materials provided with the distribution.
+ *
+ * * Neither the name of Google, Inc. nor the names of its contributors may be
+ *   used to endorse or promote products derived from this software without
+ *   specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL GOOGLE, INC. OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+ * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
+ * DAMAGE.
+ */
+
+#ifdef X86
+#    define LOOP_TEST_REG DR_REG_XBX
+#    define LOOP_TEST_REG_ASM REG_XBX
+#    define LOOP_TEST_REG_SIG SC_XBX
+#    define LOOP_COUNT_REG DR_REG_R12
+#    define LOOP_COUNT_REG_ASM REG_R12
+#    define LOOP_COUNT_REG_SIG SC_R12
+#endif
+
+#define LOOP_COUNT 100000000
diff --git a/suite/tests/linux/mangle_asynch.c b/suite/tests/linux/mangle_asynch.c
new file mode 100644
index 0000000000..cf640c3807
--- /dev/null
+++ b/suite/tests/linux/mangle_asynch.c
@@ -0,0 +1,176 @@
+/* **********************************************************
+ * Copyright (c) 2015-2018 Google, Inc.  All rights reserved.
+ * **********************************************************/
+
+/*
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * * Redistributions of source code must retain the above copyright notice,
+ *   this list of conditions and the following disclaimer.
+ *
+ * * Redistributions in binary form must reproduce the above copyright notice,
+ *   this list of conditions and the following disclaimer in the documentation
+ *   and/or other materials provided with the distribution.
+ *
+ * * Neither the name of Google, Inc. nor the names of its contributors may be
+ *   used to endorse or promote products derived from this software without
+ *   specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL GOOGLE, INC. OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+ * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
+ * DAMAGE.
+ */
+
+#ifndef ASM_CODE_ONLY /* C code */
+#    include "tools.h"
+#    include "mangle_asynch-shared.h"
+#    include <setjmp.h>
+#    include <signal.h>
+#    include <pthread.h>
+
+volatile bool test_ready = false;
+volatile bool test_done = false;
+volatile int loop_inc = 1;
+
+/* asm routines */
+void
+test_asm();
+
+static SIGJMP_BUF mark;
+
+static void
+handle_signal(int signal, siginfo_t *siginfo, ucontext_t *ucxt)
+{
+#    ifdef X86_64
+    if (signal == SIGILL) {
+        sigcontext_t *sc = SIGCXT_FROM_UCXT(ucxt);
+        if (sc->LOOP_COUNT_REG_SIG != LOOP_COUNT)
+            print("ERROR: incorrect result!\n");
+        SIGLONGJMP(mark, 1);
+    } else if (signal != SIGUSR2) {
+        print("Unexpected signal!\n");
+    }
+#    endif
+}
+
+static void *
+thread_routine(void *arg)
+{
+#    ifdef X86_64
+    pthread_t main_thread = *(pthread_t *)arg;
+    while (!test_ready) {
+        /* Empty. */
+    }
+    struct timespec sleeptime;
+    sleeptime.tv_sec = 0;
+    sleeptime.tv_nsec = 1000 * 1111;
+    while (!test_done) {
+        pthread_kill(main_thread, SIGUSR2);
+        nanosleep(&sleeptime, NULL);
+    }
+#    endif
+    return NULL;
+}
+
+int
+main(int argc, const char *argv[])
+{
+#    define NUM_THREADS 8
+    pthread_t thread[NUM_THREADS];
+    void *retval;
+    pthread_t main_thread = pthread_self();
+
+    for (int i = 0; i < NUM_THREADS; ++i) {
+        if (pthread_create(&thread[i], NULL, thread_routine, &main_thread) != 0) {
+            perror("Failed to create thread");
+            exit(1);
+        }
+    }
+
+    intercept_signal(SIGILL, (handler_3_t)&handle_signal, false);
+    intercept_signal(SIGUSR2, (handler_3_t)&handle_signal, false);
+
+    /* Test loop counter using mangled rip-rel instruction, interrupted by asynch
+     * signals.
+     */
+    if (SIGSETJMP(mark) == 0) {
+        test_asm();
+    }
+
+    for (int i = 0; i < NUM_THREADS; ++i) {
+        if (pthread_join(thread[i], &retval) != 0)
+            perror("Failed to join thread");
+    }
+
+    print("Test finished\n");
+    return 0;
+}
+
+#else /* asm code *************************************************************/
+#    include "asm_defines.asm"
+#    include "mangle_asynch-shared.h"
+/* clang-format off */
+START_FILE
+
+#ifdef X64
+# define FRAME_PADDING 0
+#else
+# define FRAME_PADDING 0
+#endif
+
+#define FUNCNAME test_asm
+        DECLARE_FUNC_SEH(FUNCNAME)
+GLOBAL_LABEL(FUNCNAME:)
+#ifdef X86
+#ifdef X64
+        PUSH_CALLEE_SAVED_REGS()
+        sub      REG_XSP, FRAME_PADDING /* align */
+        END_PROLOG
+
+        jmp      test
+     test:
+        mov      BYTE SYMREF(test_ready), HEX(1)
+        mov      LOOP_TEST_REG_ASM, LOOP_COUNT
+        mov      LOOP_COUNT_REG_ASM, 0
+      loop:
+        /* The address will get mangled into REG_XAX. */
+        add      LOOP_COUNT_REG_ASM, PTRSZ SYMREF(loop_inc)
+        sub      LOOP_TEST_REG_ASM, 1
+        cmp      LOOP_TEST_REG_ASM, 0
+        jnz      loop
+        jmp      epilog
+     epilog:
+        mov      BYTE SYMREF(test_done), HEX(1)
+        /* This will trigger the SIGILL handler which ensures there was no extra
+         * add within the loop from re-execution due to translating back.
+         */
+        ud2
+        add      REG_XSP, FRAME_PADDING /* make a legal SEH64 epilog */
+        POP_CALLEE_SAVED_REGS()
+#endif
+        ret
+#elif defined(ARM)
+        /* XXX i#3289: prologue missing */
+        /* Test 8: not implemented for ARM */
+        bx       lr
+#elif defined(AARCH64)
+        /* XXX i#3289: prologue missing */
+        /* Test 8: not implemented for AARCH64 */
+        ret
+#endif
+        END_FUNC(FUNCNAME)
+#undef FUNCNAME
+
+END_FILE
+
+/* clang-format on */
+#endif
diff --git a/suite/tests/linux/mangle_asynch.expect b/suite/tests/linux/mangle_asynch.expect
new file mode 100644
index 0000000000..5d024cd516
--- /dev/null
+++ b/suite/tests/linux/mangle_asynch.expect
@@ -0,0 +1 @@
+Test finished
